﻿SuperStrict

Global ResX:Int = 600
Global resY:Int = 600
Graphics(ResX, resY, 0, 60, 0)
Include "Tperson.bmx"
Include "global.res.bmx"
Include "funcs.bmx"
SetBlend(ALPHABLEND)
CreateGame()
pregame()
SetHArdness(3)

Function pregame()
	While Not KeyHit(KEY_ESCAPE)
		SetColor(169, 0, 0)
		DrawRect(0, 0, ResX, resY)
		SetColor(255, 255, 255)
		SetScale(4, 4)
			DrawText("FuzzBomb", 100, 10)
		SetScale(1, 1)
		DrawText("Tag/Nacht spiel fuer den BCC #52 von Blitzforum.de", 100, 100)
	 	SetColor(Rand(0, 255), Rand(0, 255), Rand(0, 255))
		If GameRunning Then
				DrawText("Spiel Pausiert!, Leertaste zum fortfahren.", 100, 150)
				DrawText("oder Eingabetaste fuer ein neues Spiel!", 100, 165)
				If KeyDown(KEY_SPACE) Then GameLoop()
			Else
				DrawText("Eingabetaste fuer ein Neues Spiel!", 100, 150)
		EndIf
		SetColor(255, 255, 255)
		
		If KeyHit(KEY_1) Then SetHArdness(1) ;GameRunning = 0
		If KeyHit(KEY_2) Then SetHArdness(2) ;GameRunning = 0
		If KeyHit(KEY_3) Then SetHArdness(3) ;GameRunning = 0
		If KeyHit(KEY_4) Then SetHArdness(4) ;GameRunning = 0
		If KeyHit(KEY_5) Then SetHArdness(5) ;GameRunning = 0
		
		DrawText("Zahlentasten fuer Schwierigkeitsgrad: 1-5", 100, 220)
		DrawText("Schwierigkeit:" + Hardness, 120, 245)
		DrawText("Personen:" + Persons, 120, 260)
		DrawText("Fuzzler:" + setFuzzlers, 120, 275)
		DrawText("Gier:" + persongier, 120, 290)

		DrawText("Faszination der Fuzzbomb:" + FuzzBombFaszination, 320, 260)
		DrawText("Mitoserate der Diamanten:" + (600 - DiamondSpawnPercent), 320, 275)
		Print DiamondSpawnPercent
		DrawText("Fuzzler Lauf geschwindigkeit:" + fuzzspeed, 320, 290)
		
				
		
				
		DrawText("Mission:", 100, 300)
		DrawText("Finde und vernichte die FuzzBomb", 100, 320)
		DrawImageRect(GfxMove, 100, 340, 50, 50, 32 + Rand(0, 6))
		DrawText("Du must mindestens 100 Diamanten besitzen,", 155, 345)
		DrawText("und dich mit der Fuzzbomb vereinen.", 155, 360)
		DrawText("Vorzugsweise am tage....", 155, 375)
		DrawText("Tipps:", 100, 390)
		DrawImageRect(GfxTile, 100, 410, 20, 20, 2)
		DrawText("Diamanten vermehren sich, wenn sie in der Sonne liegen!", 120, 415)

		DrawImageRect(GfxMove, 100, 430, 20, 20, 0)
		DrawText("Pass auf, die leute sammeln die Diamanten gerne ein...", 120, 435)

		DrawImageRect(GfxMove, 100, 450, 20, 20, 16)
		DrawText("Fuzz breitet sich aus.", 120, 455)
		
		DrawText("Wenn eine gefuzzte Person eine normale Person beruert:", 120, 475)
		DrawText("halbieren sich die Diamanten der normalen Person", 120, 485)
		DrawText("Hat die person keine Diamanten mehr wird sie Fuzzed.", 120, 495)
		
		DrawText("Achtung! Gefuzzte Personen sind unsichtbar bei Nacht!", 120, 515)

		If KeyDown(KEY_ENTER) Then
			SeedRnd(MilliSecs())
			GameRunning = 1
			CreateGame()
			GameLoop()
		EndIf
		
		Flip(0)
		
	
	
	Wend
End Function


Function GameLoop:Int()
	While Not KeyHit (KEY_ESCAPE)
		FfacX = (Player.Posx) + (ResX / 2)
		FfacY = (Player.PosY) + (resY)
		Cls()
		ActualTime = MilliSecs()
		If KeyHit(KEY_ESCAPE) Then Return 1
		If GameRunning = 0 Then Return 1
		If LastUpdateTime + 30 < ActualTime Then 'mover update nur alle 30 ms ausführen.
			LastUpdateTime = ActualTime
			
			DayTime:+0.2
			If DayTime > 240 Then DayTime = 0;Days:+1
			DayCol = Sin(DayTime)
			If DayTime > 10 And DayTime < 150 Then SpawnDiamond()
			SetColor(DayCol * 399, DayCol * 256, 128 + Abs(DayCol * 128))
			DrawMap()
			UpdatePersons()
			DrawMapOverlay()
			DrawHud()
			
			Flip(0)

		End If
	Wend
End Function

'leben
Function UpdatePersons()
	Fuzzlers = 0
	Local ActPerson:tmover
	Local SecPerson:tmover
	Local SecundaryList:TList = personlist.Copy()
	For ActPerson = EachIn PersonList
		For SecPerson = EachIn SecundaryList
			If SecPerson <> ActPerson Then
				If CollTest(ActPerson.PosX, SecPerson.PosX, ActPerson.PosY, SecPerson.PosY, ActPerson.Size) Then
					ActPerson.CollidedPerson = Tperson(SecPerson)
					SecPerson.CollidedPerson = Tperson(ActPerson)
				EndIf
			EndIf
		Next
		SecundaryList.Remove(ActPerson)
		ActPerson.Update()
		If actPErson.PosX - Player.posx < (ResX / 2)
			If actPErson.PosY - Player.posY < (ResX / 2)
			actPErson.DrawMe()
			EndIf
		EndIf
	If Tfuzzler(actperson) Then fuzzlers:+1
	Next
End Function
'
'Function DrawPersons()
'	Local ActPerson:tMover
'	For actPErson = EachIn PersonList
'		
'	Next	
'End Function

'zeichnen
Function DrawMap()
	Local ActX:Int
	Local acty:Int
	For ActX:Int = (Player.posx / 8) - 40 Until (Player.posx / 8) + 40
	For acty:Int = (Player.posy / 8) - 40 Until (Player.posy / 8) + 40
		If ActX > - 1 And ActX < MapSizeX + 1 And ActY > - 1 And ActY < MapSizeY + 1 Then
			If Map[ActX, acty] = 0 Or Map[ActX, acty] > 1 Then DrawImage(GfxTile, ActX * 8 - (Player.Posx) + (ResX / 2), acty * 8 - (Player.PosY) + (resY / 2), 0)
		End If
	Next
	Next
End Function

Function SpawnDiamond()
	Local ActY:Int
	Local aim:Int
	For Local ActX:Int = 1 Until MapSizeX - 1
	For ActY:Int = 1 Until MapSizeY - 1
	
		If Map[ActX, ActY] = 2'diamond
			If Rand(0, 600) > DiamondSpawnPercent Then
			Local sel:Int = Rand(0, 4)
				Select sel
					Case 0
						If Map[ActX - 1, ActY] = 0 Then
							Map[ActX - 1, ActY] = 2
							Effect.CreateNew((ActX - 1) * 8 + 4, ActY * 8 + 4)
						End If
					Case 1
						If Map[ActX + 1, ActY] = 0 Then
							Map[ActX + 1, ActY] = 2
							Effect.CreateNew((ActX + 1) * 8 + 4, ActY * 8 + 4)
						End If
					Case 2
						If Map[ActX, ActY + 1] = 0 Then
							Map[ActX, ActY + 1] = 2
							Effect.CreateNew(ActX * 8 + 4, (ActY + 1) * 8 + 4)
						End If
					Case 3
						If Map[ActX, ActY - 1] = 0 Then
							Map[ActX, ActY - 1] = 2
							Effect.CreateNew(ActX * 8 + 4, (ActY - 1) * 8 + 4)
						End If
				End Select
			
				
			EndIf
			If Rand(0, 10) = 5 Then
				If aim < persongier Then
					aim:+1
					Local dings:tperson = tperson(PersonList.ValueAtIndex(Rand(0, PersonList.Count() - 1)))
					If dings And dings.typ = 0 And dings.aimed < 0 Then 'normaler hutmensch^^
						If dings.PosX / 8 < ActX And dings.PosY / 8 < ActY Then
							Tperson(dings).Direction = 4
						ElseIf dings.PosX / 8 > ActX And dings.PosY / 8 < ActY Then
							Tperson(dings).Direction = 6
						ElseIf dings.PosX / 8 > ActX And dings.PosY / 8 > ActY Then
							Tperson(dings).Direction = 8
						ElseIf dings.PosX / 8 < ActX And dings.PosY / 8 > ActY Then
							Tperson(dings).Direction = 2
						ElseIf dings.PosX / 8 < ActX Then
							Tperson(dings).Direction = 7
						ElseIf dings.PosX / 8 > ActX Then
							Tperson(dings).Direction = 3
						ElseIf dings.Posy / 8 < Acty Then
							Tperson(dings).Direction = 1
						ElseIf dings.Posy / 8 > Acty Then
							Tperson(dings).Direction = 5
						EndIf
						dings.aimed = Abs((dings.PosX - ActX * 8) + (dings.PosY - ActY * 8)) / 2
					End If
				EndIf
			EndIf
		End If
		

	Next
	Next
	
	

End Function

Function DrawMapOverlay()
	Local ActX:Int
	Local acty:Int
	For ActX:Int = (Player.posx / 8) - 40 Until (Player.posx / 8) + 40
	For acty:Int = (Player.posy / 8) - 40 Until (Player.posy / 8) + 40
		If ActX > - 1 And ActX < MapSizeX + 1 And ActY > - 1 And ActY < MapSizeY + 1 Then
			If Map[ActX, acty] = 1 Then DrawImage(GfxTile, ActX * 8 - (Player.Posx) + (ResX / 2), acty * 8 - (Player.PosY) + (resY / 2), Map[ActX, acty])
			If Map[ActX, acty] = 2 Then
			DrawImage(GfxTile, ActX * 8 - (Player.Posx) + (ResX / 2), acty * 8 - (Player.PosY) + (resY / 2), Map[ActX, acty])
			EndIf
		End If
	Next
	Next
End Function



Function DrawHud()
	SetAlpha(0.5)
	SetColor(255, 255, 255)
'	DrawRect(0, 0, 600, 40)
'	DrawRect(0, 0, 600, 35)
'	DrawRect(0, 0, 600, 30)
	SetAlpha(1)
	
	'DrawImage(GfxMove, 390, 10, 240 + DayTime / 15)
	DrawImageRect(GfxMove, 0, 0, 600, 40, 239 + DayTime / 15)
	DrawImage(GfxTile, 10, 10, 2)
	DrawText(":" + Player.Diamonds, 20, 8)
	DrawImage(GfxMove, ResX - 150, 8, 16)
	DrawText(":" + Fuzzlers, ResX - 140, 10)
	DrawText("Day: " + Days, ResX - 80, 10)
	DrawText("Ticker:" + StatusMSG, 60, 8)
	If Player.typ = 2 Then
		SetScale(4, 4)
			SetColor(Rand(0, 255), Rand(0, 255), Rand(0, 255))
			DrawText("YOU ARE FUZZED", 50, 200)
		SetScale(1, 1)
		DrawText("Vieleicht gibt es noch hoffnung und Rennst in einen Diamanten...", 50, 380)
		DrawText("ESC -> Menu", 50, 400)
	EndIf
	If Not tFuzzBomb(PersonList.First()) Then
		SetScale(4, 4)
			SetColor(Rand(0, 255), Rand(0, 255), Rand(0, 255))
			DrawText("GESCHAFT", 50, 200)
		SetScale(1, 1)
		DayTime = 12
		DrawText("Du hast die Fuzz bomb ausgelöscht!", 50, 380)
		DrawText("ESC -> Menu", 50, 400)		
	End If
End Function