Type tMover
	Field relFrame:Int
	Field typ:Int
	Field PosX:Int
	Field PosY:Int
	Field CollidedPerson:tperson
	Field Size:Int = 8
	Method drawme()
		DrawImage(GfxMove, PosX - 8 - (Player.PosX) + (ResX / 2), PosY - 8 - (Player.PosY) + (resY / 2), (typ * 8) + relFrame)
	End Method
	Method Update()
	End Method
End Type
Type tFuzzBomb Extends tperson
	Method Update()
		Local aim:Int = 0
		While aim < FuzzBombFaszination
					aim:+1
					Local dings:tperson = tperson(PersonList.ValueAtIndex(Rand(0, PersonList.Count() - 1)))
					If dings And dings.typ = 0 And dings.aimed = 0 Then 'normaler hutmensch^^
						If dings.PosX < PosX And dings.PosY < PosY Then
							Tperson(dings).Direction = 4
						ElseIf dings.PosX > PosX And dings.PosY < PosY Then
							Tperson(dings).Direction = 6
						ElseIf dings.PosX > PosX And dings.PosY > PosY Then
							Tperson(dings).Direction = 8
						ElseIf dings.PosX < PosX And dings.PosY > PosY Then
							Tperson(dings).Direction = 2
						ElseIf dings.PosX < PosX Then
							Tperson(dings).Direction = 3 
						ElseIf dings.PosX > PosX Then
							Tperson(dings).Direction = 7
						ElseIf dings.PosY < PosY Then
							Tperson(dings).Direction = 5
						ElseIf dings.PosY > PosY Then
							Tperson(dings).Direction = 1
						EndIf
						dings.aimed = Abs((dings.PosX - PosX * 8) + (dings.PosY - PosY * 8))
					End If
		Wend
	
		If Self.CollidedPerson Then
			If CollidedPerson.typ = 0 Then
				Local NewFuzzler:tfuzzler = New Tfuzzler
				NewFuzzler.PosX = CollidedPerson.PosX
				NewFuzzler.PosY = CollidedPerson.PosY
				NewFuzzler.Direction = CollidedPerson.Direction
				PersonList.Remove(CollidedPerson)
				PersonList.AddLast(NewFuzzler)
				NewFuzzler.typ = 2
				CollidedPerson.CollidedPerson = Null
				CollidedPerson = Null
			ElseIf CollidedPerson.typ = 1 Then
				If CollidedPerson.Diamonds < 100
					Local NewFuzzler:tfuzzler = New Tfuzzler
					NewFuzzler.PosX = CollidedPerson.PosX
					NewFuzzler.PosY = CollidedPerson.PosY
					NewFuzzler.Direction = CollidedPerson.Direction
					PersonList.Remove(CollidedPerson)
					PersonList.AddLast(NewFuzzler)
					NewFuzzler.typ = 2
					Player = NewFuzzler
					CollidedPerson.CollidedPerson = Null
					CollidedPerson = Null
				Else
					YouWon()
				EndIf
			EndIf
		End If
		Self.relFrame:+1
		If relFrame > 7 Then Self.relFrame = 0
	End Method
End Type
Type Effect Extends TMover 'typ3
	Method drawme()
		Local R:Int
		Local G:Int
		Local B:Int
		GetColor(R, G, B)
		SetColor(255, 255, 255)
		DrawImage(GfxMove, PosX - 8 - (Player.PosX) + (ResX / 2), PosY - 8 - (Player.PosY) + (resY / 2), (typ * 8) + relFrame)
		SetColor(R, G, B)
	End Method
	Method Update()
		Self.relFrame:+1
		If relFrame > 7 Then PersonList.Remove(Self)
	End Method
	Function CreateNew(x:Int, y:Int)
		If x - Player.PosX < (ResX / 2)
			If y - Player.PosY < (ResX / 2)
					Local newFX:Effect = New Effect
		newFX.PosX = x
		newFX.PosY = y
		newFX.typ = 3
		PersonList.AddLast(newFX)
			EndIf
		EndIf

	End Function
End Type
Type Tperson Extends tmover
	Field Direction:Int
	Field Diamonds:Int
	Field aimed:Int = 0
	Field speed:Int = PresSpeed
	Method Update()
		Self.aimed:-1
		'if speed = PresSpeed
		If Self.aimed < 0 Then
			Select Rand(0, 10)
			Case 1
				For Local ActX:Int = 1 Until MapSizeX - 1
					If Map[ActX, PosY / 8] = 2 Then
						If ActX < PosX / 8 Then
							Self.Direction = 7'w
						Else
							Self.Direction = 8'w	
						End If
					End If
				Next
			Case 2
				For Local Acty:Int = 1 Until MapSizeY - 1
					If Map[PosX / 8, Acty] = 2 Then
						If PosY / 8 < Acty Then
							Self.Direction = 5's
						Else
							Self.Direction = 1'w	
						End If
					End If
				Next
			End Select
			Self.aimed = 10
		End If
		If Self.CollidedPerson Then
			If Self.typ = 2 Then
					'boom
				Effect.CreateNew(CollidedPerson.PosX, CollidedPerson.PosY)
			End If
			If Self.CollidedPerson.Typ = 2 And Self.Typ = 0 Then 'fuzzler 
				If Self.Diamonds > 0 Then
					Self.Diamonds:/2
					Self.Direction = Self.CollidedPerson.Direction
					CollidedPerson.Direction = Rnd(1, 8)
				Else
					Local NewFuzzler:tfuzzler = New Tfuzzler
					NewFuzzler.PosX = Self.PosX
					NewFuzzler.PosY = Self.PosY
					NewFuzzler.Direction = Self.Direction
					PersonList.Remove(Self)
					PersonList.AddLast(NewFuzzler)
					StatusMSG = "Einen hats erwischt: fuzzeD :("
				EndIf
			ElseIf Self.CollidedPerson.Typ = 1 Then 'player
				If Player.Direction > 0 Then
					Self.Direction = Player.Direction
				Else
					Self.Direction:+4
					
					If Self.Direction > 8 Then Self.Direction:-8
				EndIf
			Else
				Self.Direction = Rnd(1, 8)
			EndIf
			Self.CollidedPerson = Null
		EndIf
			Select Self.Direction
				Case 1'N
					If Map[((Self.PosX) / 8), ((Self.PosY - speed) / 8)] = 1 Then
						Self.Direction = 5
					Else
						Self.PosY:-speed
					EndIf
				Case 2'NO
					If Map[((Self.PosX) / 8), ((Self.PosY - speed) / 8)] = 1 Then
						Self.Direction = 4
					Else
						Self.PosY:-speed
					EndIf
					If Map[((Self.PosX + speed) / 8), ((Self.PosY) / 8)] = 1 Then
						Self.Direction = 8
					Else
						Self.PosX:+speed
					EndIf
				Case 3'O
					If Map[((Self.PosX + speed) / 8), ((Self.PosY) / 8)] = 1 Then
						Self.Direction = 7
					Else
						Self.PosX:+speed
					EndIf
				Case 4'SO
					If Map[((Self.PosX + speed) / 8), ((Self.PosY) / 8)] = 1 Then
						Self.Direction = 6
					Else
						Self.PosX:+speed
					EndIf
					If Map[((Self.PosX) / 8), ((Self.PosY + speed) / 8)] = 1 Then
						Self.Direction = 2
					Else
						Self.PosY:+speed
					EndIf
				Case 5'S
					If Map[((Self.PosX) / 8), ((Self.PosY + speed) / 8)] = 1 Then
						Self.Direction = 1
					Else
						Self.PosY:+speed
					EndIf
				Case 6'SW
					If Map[((Self.PosX) / 8), ((Self.PosY + speed) / 8)] = 1 Then
						Self.Direction = 8
					Else
						Self.PosY:+speed
					EndIf
					If Map[((Self.PosX - speed) / 8), ((Self.PosY) / 8)] = 1 Then
						Self.Direction = 4
					Else
						Self.PosX:-speed
					EndIf
				Case 7'W
					If Map[((Self.PosX - speed) / 8), ((Self.PosY) / 8)] = 1 Then

						Self.Direction = 3

					Else
						Self.PosX:-speed
					EndIf
				Case 8'NW			
					If Map[((Self.PosX - speed) / 8), ((Self.PosY) / 8)] = 1 Then
						Self.Direction = 2
					Else
						Self.PosX:-speed
					EndIf
					If Map[((Self.PosX) / 8), ((Self.PosY - speed) / 8)] = 1 Then
						Self.Direction = 6
					Else
						Self.PosY:-speed

					EndIf
			End Select
			'diamantentest
			If Map[Self.PosX / 8, Self.PosY / 8] = 2 Then
				Map[Self.PosX / 8, Self.PosY / 8] = 0
				If Self.typ = 2 Then
					StatusMSG = "Jemand wurde Unfuzzed! :)"
					Local newperson:tperson = New tperson
					newperson.PosX = Self.PosX
					newperson.PosY = Self.PosY
					newperson.Direction = Self.Direction
					PersonList.Remove(Self)
					PersonList.AddLast(newperson)
					Effect.CreateNew(Self.PosX, Self.PosY)
				Else
					Self.Diamonds:+1
				End If
				
			EndIf
		Self.CollidedPerson = Null
		Self.relFrame:+1
		If Self.relFrame > 7 Then Self.relFrame = 0
	End Method
End Type

Type Tfuzzler Extends Tperson
	Method New()
		Self.typ = 2
		Self.speed = fuzzspeed
	End Method
	Method drawme()
		If Self = Player Then StatusMSG = "You are Fuzzed!"
		SetAlpha(((150.0 * DayCol) / 100))
		DrawImage(GfxMove, PosX - 8 - (Player.PosX) + (ResX / 2), PosY - 8 - (Player.PosY) + (resY / 2), (typ * 8) + relFrame)
		SetAlpha(1)
	End Method
End Type

Type Tplayer Extends Tperson
	Method New()
		Self.Typ = 1
		Self.speed = 2
	End Method
	Method Update()
			If Map[Self.PosX / 8, Self.PosY / 8] = 2 Then
				Map[Self.PosX / 8, Self.PosY / 8] = 0
				Self.Diamonds:+1
			EndIf
		If Self.CollidedPerson Then
			Self.speed = 1
			If Self.CollidedPerson.Typ = 2 Then 'fuzzler
				If Self.Diamonds > 1 Then
				Self.Diamonds:/2
				Self.speed = -8
			Else
				Local NewFuzzler:tfuzzler = New Tfuzzler
				NewFuzzler.PosX = Self.PosX
				NewFuzzler.PosY = Self.PosY
				NewFuzzler.Direction = Rnd(1, 8)
				PersonList.Remove(Self)
				Player = NewFuzzler
				Player.speed = 2
				PersonList.AddLast(NewFuzzler)
				gameover()
				EndIf
			EndIf
			Self.CollidedPerson = Null
		Else
			Self.speed = 2
		EndIf
	'	Self.Direction = 0
		Local moved:Int
		If KeyDown(KEY_W) Then
			If Map[((Self.PosX) / 8), ((Self.PosY - speed) / 8)] <> 1 Then
				Self.PosY:-speed
				moved = 1
				Self.Direction = 1
			EndIf
		EndIf
		If KeyDown(KEY_S) Then
			If Map[((Self.PosX) / 8), ((Self.PosY + speed) / 8)] <> 1 Then
				Self.PosY:+speed
				moved = 1
				Self.Direction = 5
			EndIf
		EndIf
		If KeyDown(KEY_A) Then
			If Map[((Self.PosX - speed) / 8), ((Self.PosY) / 8)] <> 1 Then
			
				Self.PosX:-speed
				moved = 1
				If Self.Direction = 1 Then
					Self.Direction = 8
				ElseIf Self.Direction = 5 Then
					Self.Direction = 6
				Else
					Self.Direction = 7
				EndIf
			EndIf
		EndIf
		If KeyDown(KEY_D) Then
			If Map[((Self.PosX + speed) / 8), ((Self.PosY) / 8)] <> 1 Then
			
				Self.PosX:+speed
				moved = 1
				If Self.Direction = 1 Then
					Self.Direction = 2
				ElseIf Self.Direction = 5 Then
					Self.Direction = 4
				Else
					Self.Direction = 3
				EndIf
			EndIf
		EndIf
		If KeyHit(KEY_SPACE) Then
			If Diamonds > 0 Then
			Select Self.Direction
				Case 1'N
					If Map[((Self.PosX) / 8), ((Self.PosY + 8) / 8)] = 0 Then
					Map[((Self.PosX) / 8), ((Self.PosY + 8) / 8)] = 2
					Diamonds:-1
					EndIf
				Case 2'NO
					If Map[((Self.PosX - 8) / 8), ((Self.PosY + 8) / 8)] = 0 Then
					Map[((Self.PosX - 8) / 8), ((Self.PosY + 8) / 8)] = 2
					Diamonds:-1
					EndIf
				Case 3'O
					If Map[((Self.PosX - 8) / 8), ((Self.PosY) / 8)] = 0 Then
					Map[((Self.PosX - 8) / 8), ((Self.PosY) / 8)] = 2
					Diamonds:-1
					EndIf
				Case 4'SO
					If Map[((Self.PosX - 8) / 8), ((Self.PosY - 8) / 8)] = 0 Then
					Map[((Self.PosX - 8) / 8), ((Self.PosY) / 8)] = 2
					Diamonds:-1
					EndIf
				Case 5'S
					If Map[((Self.PosX) / 8), ((Self.PosY - 8) / 8)] = 0 Then
					Map[((Self.PosX) / 8), ((Self.PosY - 8) / 8)] = 2
					Diamonds:-1
					EndIf
				Case 6'SW
					If Map[((Self.PosX + 8) / 8), ((Self.PosY - 8) / 8)] = 0 Then
					Map[((Self.PosX + 8) / 8), ((Self.PosY - 8) / 8)] = 2
					Diamonds:-1
					EndIf
				Case 7'W
					If Map[((Self.PosX + 8) / 8), ((Self.PosY) / 8)] = 0 Then
					Map[((Self.PosX + 8) / 8), ((Self.PosY) / 8)] = 2
					Diamonds:-1
					EndIf
				Case 8'NW			
					If Map[((Self.PosX + 8) / 8), ((Self.PosY + 8) / 8)] = 0 Then
					Map[((Self.PosX + 8) / 8), ((Self.PosY + 8) / 8)] = 2
					Diamonds:-1
					EndIf
			End Select
			Else
			EndIf
		End If
		If Moved Then
			Self.relFrame:+1
		End If
		
		If Self.relFrame > 7 Then Self.relFrame = 0
	End Method
End Type